<?php
/*
Program Structures
*/
//page 89 code listing
// Show all errors
error_reporting(E_ALL);

$arr = array('fruit' => 'apple', 'veggie' => 'carrot');

// Correct
echo $arr['fruit'];  // apple
echo $arr['veggie']."</br>"; // carrot

// Incorrect.  This works but also throws a PHP error of level E_NOTICE because
// of an undefined constant named fruit
// 
// Notice: Use of undefined constant fruit - assumed 'fruit' in...
echo $arr[fruit]."</br>";    // apple

// This defines a constant to demonstrate what's going on.  The value 'veggie'
// is assigned to a constant named fruit.
define('fruit', 'veggie');

// Notice the difference now
echo $arr['fruit']."</br>";  // apple
echo $arr[fruit]."</br>";    // carrot

// The following is okay, as it's inside a string. Constants are not looked for
// within strings, so no E_NOTICE occurs here
echo "Hello $arr[fruit]</br>";      // Hello apple

// With one exception: braces surrounding arrays within strings allows constants
// to be interpreted
echo "Hello {$arr[fruit]}</br>";    // Hello carrot
echo "Hello {$arr['fruit']}</br>";  // Hello apple

// This will not work, and will result in a parse error, such as:
// Parse error: parse error, expecting T_STRING' or T_VARIABLE' or T_NUM_STRING'
// This of course applies to using superglobals in strings as well
echo "Hello $arr[fruit]</br>";
echo "Hello $_GET[foo]</br>";

// Concatenation is another option
echo "Hello " . $arr['fruit']."</br>"; // Hello apple
?> 
